unit prevody_form;

{$mode objfpc}{$H+}

interface

uses
	SysUtils, StrUtils, Classes, lclintf, fpg_base, fpg_main,
	{$I prevody_form_uses} fpg_form, { text_canvas, } tools_unit;

type

	TPrevody = class(TfpgForm)
	private

		cislo1: integer;
		cislo2: integer;
		cislo1Zaloha: integer;
		cislo2Zaloha: integer;
		editCislo1Text: string;
		editCislo2Text: string;

		{$I prevody_form_decl}

		procedure addMemoLine(text1: UTF8String; text2: UTF8String);

	public

		procedure btnGenerujClicked(Sender: TObject);
		procedure btnUpravClicked(Sender: TObject);
		procedure btnZadajClicked(Sender: TObject);
		procedure btnZrusClicked(Sender: TObject);
		procedure btnPrevedClicked(Sender: TObject);
		procedure btnInvertujClicked(Sender: TObject);
		procedure btnScitajClicked(Sender: TObject);
		procedure btnOdcitajClicked(Sender: TObject);

		{#LINK_BEGIN}
		procedure linkClicked(Sender: TObject);
		procedure linkPressed(Sender: TObject;
			AChar: TfpgChar; var Consumed: boolean);
		{#LINK_END}

		procedure AfterCreate; override;

	end;

{@VFD_NEWFORM_DECL}


implementation


// uses fpg_dialogs; // Keďže už nepoužívame ShowMessage, tak toto netreba.

{@VFD_NEWFORM_IMPL}

procedure TPrevody.addMemoLine(text1: UTF8String; text2: UTF8String);
// var concats: string;
begin
	{ Nasledujúci spôsob (v komentári) nefungoval. Napriek pripojeniu
	  ASCII kódu LF #10 neboli do komponentu informačnej poznámky
	  (memoInformacie) vložené nové riadky. (Všetok obsah sa pripájal
	  do jedného automaticky zalamovaného riadka. ASCII kód #10 bol
	  z nejakého dôvodu ignorovaný. Rovnaký výsledok bol dosiahnutý
	  aj pri použití kombinácie CRLF: #13#10.) }

	{ concats := ConcatUTF8Strings(memoInformacie.Text, text1);
	  concats := ConcatUTF8Strings(concats, text2);
	  memoInformacie.Text := ConcatUTF8Strings(concats, #10);
	  memoInformacie.Lines.Insert(0, IntToStr(memoInformacie.Lines.Count)); }

	if '' = text2 then
		memoInformacie.Lines.Insert(memoInformacie.Lines.Count - 1, text1)
	else
		memoInformacie.Lines.Insert(memoInformacie.Lines.Count - 1,
			ConcatUTF8Strings(text1, text2));
end;

procedure TPrevody.btnGenerujClicked(Sender: TObject);
begin
	memoInformacie.Text := '';
	{ Canvas1.clearText(); }

	cislo1 := round(int(random * 256)) - 128;
	editCislo1.Text := IntToStr(cislo1);

	cislo2 := round(int(random * 256)) - 128;
	editCislo2.Text := IntToStr(cislo2);

	editBinarne1.Text := '';
	editBinarne2.Text := '';

	editInvertovane1.Text := '';
	editInvertovane2.Text := '';

	editSucet.Text := '';
	editRozdiel.Text := '';
end;

procedure TPrevody.btnUpravClicked(Sender: TObject);
begin
	// addMemoLine('Image margin: ', IntToStr(btnUprav.ImageMargin));
	// addMemoLine('Image spacing: ', IntToStr(btnUprav.ImageSpacing));

	btnGeneruj.Visible := False;
	btnUprav.Visible := False;

	btnZadaj.Visible := True;
	btnZrus.Visible := True;

	btnPreved.Enabled := False;
	btnInvertuj.Enabled := False;
	btnScitaj.Enabled := False;
	btnOdcitaj.Enabled := False;

	editCislo1.ReadOnly := False;
	editCislo2.ReadOnly := False;

	editCislo1Text := editCislo1.Text;
	editCislo2Text := editCislo2.Text;

	cislo1Zaloha := cislo1;
	cislo2Zaloha := cislo2;
end;

procedure TPrevody.btnZadajClicked(Sender: TObject);
var okay: boolean = True;
begin
	{ Canvas1.clearText(); }

	if '' = editCislo1.Text then
	begin
		okay := False;
		addMemoLine('Nebola zadaná prvá hodnota.', '')
	end
	else
	try
		cislo1 := StrToInt(editCislo1.Text)
	except
		on E : EConvertError do
		begin
			okay := False;
			addMemoLine('Neplatná prvá zadaná hodnota: ',
				editCislo1.Text)
			{ Canvas1.addLine('Neplatná prvá zadaná hodnota: ',
				editCislo1.Text) }
		end
	end;

	if '' = editCislo2.Text then
	begin
		okay := False;
		addMemoLine('Nebola zadaná druhá hodnota.', '')
	end
	else
	try
		cislo2 := StrToInt(editCislo2.Text)
	except
		on E : EConvertError do
		begin
			okay := False;
			addMemoLine('Neplatná druhá zadaná hodnota: ',
				editCislo2.Text)
			{ Canvas1.addLine('Neplatná druhá zadaná hodnota: ',
				editCislo2.Text) }
		end
	end;

	if okay then
	begin
		editCislo1Text := IntToStr(cislo1);
		editCislo2Text := IntToStr(cislo2);

		cislo1Zaloha := cislo1;
		cislo2Zaloha := cislo2;

		btnZrusClicked(Sender);
	
		editBinarne1.Text := '';
		editBinarne2.Text := '';
	
		editInvertovane1.Text := '';
		editInvertovane2.Text := '';
	
		editSucet.Text := '';
		editRozdiel.Text := '';
	end
end;

procedure TPrevody.btnZrusClicked(Sender: TObject);
begin
	btnGeneruj.Visible := True;
	btnUprav.Visible := True;

	btnZadaj.Visible := False;
	btnZrus.Visible := False;

	btnPreved.Enabled := True;
	btnInvertuj.Enabled := True;
	btnScitaj.Enabled := True;
	btnOdcitaj.Enabled := True;

	editCislo1.ReadOnly := True;
	editCislo2.ReadOnly := True;

	editCislo1.Text := editCislo1Text;
	editCislo2.Text := editCislo2Text;

	cislo1 := cislo1Zaloha;
	cislo2 := cislo2Zaloha;

	memoInformacie.Text := '';
end;

procedure TPrevody.btnPrevedClicked(Sender: TObject);
begin
	if cislo1 < 0 then
		editBinarne1.Text := IntToBin(-cislo1, 8)
	else
		editBinarne1.Text := IntToBin(cislo1, 8);

	if cislo2 < 0 then
		editBinarne2.Text := IntToBin(-cislo2, 8)
	else
		editBinarne2.Text := IntToBin(cislo2, 8);
end;

procedure TPrevody.btnInvertujClicked(Sender: TObject);
begin
	if cislo1 < 0 then
		editInvertovane1.Text :=
			// Test (na porovnanie):
			// IntToBin(cislo1 xor 255, 8) + ' <> ' +
			IntToBin((-cislo1) xor 255, 8)
	else
		editInvertovane1.Text := IntToBin(cislo1, 8);

	if cislo2 < 0 then
		editInvertovane2.Text := IntToBin((-cislo2) xor 255, 8)
	else
		editInvertovane2.Text := IntToBin(cislo2, 8);
end;

procedure TPrevody.btnScitajClicked(Sender: TObject);
var sucet: integer;
begin
	sucet := cislo1 + cislo2;
	editSucet.Text := IntToBin(sucet, 8);
end;

procedure TPrevody.btnOdcitajClicked(Sender: TObject);
var rozdiel: integer;
begin
	rozdiel := cislo1 - cislo2;
	editRozdiel.Text := IntToBin(rozdiel, 8);
end;


{#LINK_BEGIN}
procedure TPrevody.linkClicked(Sender: TObject);
begin
	OpenURL('http://aplo.fiit.stuba.sk/aps/frames/generuj.php?id=1');
	OpenURL('http://aplo.fiit.stuba.sk/aps/frames/generuj.php?id=7');
	OpenURL('https://senzor.robotika.sk/sensorwiki/index.php/' +
		'Prevody_medzi_%C4%8D%C3%ADseln%C3%BDmi_s%C3%BAstavami');
	OpenDocument('zdroje\aritmetika_opakovanie.pdf');
	OpenDocument('zdroje\binarna_aritmetika.ppsx');
end;

procedure TPrevody.linkPressed(Sender: TObject;
	AChar: TfpgChar; var Consumed: boolean);
begin
	// Test (na zistenie kódu zadaného znaku):
	// 	addMemoLine('Key length: ', IntToStr(length(AChar)));
	// 	addMemoLine('Key code 1: ', IntToStr(ord(AChar[1])));

	if (1 = length(AChar)) and ((#13 = AChar[1]) or (#32 = AChar[1])) then
		linkClicked(Sender);
end;
{#LINK_END}

procedure TPrevody.AfterCreate;
begin
	cislo1 := 0;
	cislo2 := 0;
	editCislo1Text := '';
	editCislo2Text := '';
	{$I prevody_form_init}
	randomize
end;


end.