unit tools_unit;

{$mode objfpc}{$H+}

interface

uses SysUtils;

function ConcatUTF8Strings(utf8_1: UTF8String; utf8_2: UTF8String): UTF8String;
procedure Error(const msg : string);
function BinToInt(str: string): integer;

implementation

function ConcatUTF8Strings(utf8_1: UTF8String; utf8_2: UTF8String): UTF8String;
var uni_1, uni_2: UnicodeString;
begin
	uni_1 := UTF8Decode(utf8_1);
	uni_2 := UTF8Decode(utf8_2);
	uni_1 := uni_1 + uni_2;
	ConcatUTF8Strings := UTF8Encode(uni_1);
end;

procedure Error(const msg : string);
begin
	raise exception.create(Msg) at
		get_caller_addr(get_frame),
		get_caller_frame(get_frame);
end;

function BinToInt(str: string): integer;
var i, len, val: integer;
begin
	len := length(str);

	if len = 0 then
		Error('Cannot convert an empty binary string to an integer.')
	else
	begin
		val := 0;
		for i := 1 to len do
		begin
			val := val * 2;
			if str[i] = '1' then
				inc(val)
			else
				if str[i] <> '0' then
					Error('Unknown binary character (' + str[i] +
						') found at ' + IntToStr(i) + '.')
		end
	end;

	BinToInt := val;
end;

end.